import * as React from "react";
import * as Immutable from "immutable";
import { activeStatus } from "./DropItem";
import { Idrop, ISelected, treeNode } from "./combo";
import { IImmutalbeList } from "../util/immutableUtil";
type props<T> = Idrop<"tree", T>;
type states<T> = {
    immutableData: IImmutalbeList<treeNode<T>>;
    preData: T[];
    preInitComboVal: props<T>['initComboVal'];
    oldSelectedIndex: string;
    asyncDefaultVal: boolean;
};
interface IDropTree<T> {
    initState(prop: props<T>): states<T>;
}
declare class DropTree<T extends AnyObj> extends React.PureComponent<props<T>, states<T>> implements IDropTree<T> {
    static getDerivedStateFromProps(nextProps: props<AnyObj>, preState: states<AnyObj>): Partial<states<AnyObj>> | null;
    constructor(prop: props<T>);
    initState(prop: props<T>): states<T>;
    clear(): void;
    clickItem: (id?: string) => void;
    searchMap(data: T[], childField: string, key: string, textField: string): T[];
    searchFn: (key: string) => void;
    clickFnForTreeMethod: (path: string) => void;
    clickFn(index: string): void;
    checkMethod: (path: string) => void;
    checkFn(value: string): void;
    mapFn(list: IImmutalbeList<treeNode<T>>, active: activeStatus, select: IImmutalbeList<ISelected>, filedObj: {
        idField: string;
        textField: string;
        childField: string;
    }): {
        arr: Immutable.List<treeNode<T>>;
        selecte: IImmutalbeList<ISelected>;
    };
    checkForPar: (value: string) => void;
    checkForParFn(value: string): void;
    closeFn: () => void;
    toggleExpand: (index: string) => void;
    main(): React.JSX.Element;
    render(): React.JSX.Element | null;
}
export { DropTree };
declare const _default: {
    new <T>(prop: {
        data: T[];
        idField?: string | undefined;
        textField?: string | undefined;
        noIcon?: boolean | undefined;
        noSearch?: boolean | undefined;
        disabled?: boolean | undefined;
        multiply?: boolean | undefined;
        tit?: string | undefined;
        field: string;
        itemIcon?: string | undefined;
        defaultVal?: string | undefined;
        defaultEditVal?: string | undefined;
        width?: number | undefined;
        maxHeight?: number | undefined;
        dropWidth?: number | undefined;
        directionUp?: boolean | undefined;
        noRequire?: boolean | undefined;
        renderCallback?: boolean | undefined;
        ableClear?: boolean | undefined;
        initComboVal?: {
            id: string;
        } | undefined;
        clickOrCheckForbid?: ((node: treeNode<T>, field: string, selectedArr: IImmutalbeList<ISelected>) => boolean) | undefined;
        editFn?: ((e: React.ChangeEvent<HTMLInputElement>) => void) | undefined;
        formatterVal?: ((selected: IImmutalbeList<ISelected>) => React.ReactChild) | undefined;
        formatterDropItem?: ((node: treeNode<T>, path: string) => React.ReactNode) | undefined;
        formatterComboInp?: ((object: {
            drop: boolean;
            selected: IImmutalbeList<ISelected>;
            slideFn(e: React.MouseEvent<Element, MouseEvent>): void;
            clearFn(): void;
        }) => React.ReactNode) | undefined;
        clickCallback(selected: ISelected[], field: string, node?: treeNode<T> | undefined): void;
        noautoFold?: boolean | undefined;
        children?: React.ReactNode;
    } & {
        childField?: string | undefined;
        noSearch?: boolean | undefined;
        parAbleClick?: boolean | undefined;
    }): {
        eventId: string;
        filedObj: import("../util/immutableUtil").IImmutalbeMap<import("./combo").filedObj<"tree", T>, import("./combo").filedObj<"tree", T>>;
        dropStyle: {
            maxHeight: number;
        };
        selectFn: (path?: string | undefined) => void;
        bindSelectFn: (fn: (path?: string | undefined) => void) => void;
        initFieldObj(prop: {
            data: T[];
            idField?: string | undefined;
            textField?: string | undefined;
            noIcon?: boolean | undefined;
            noSearch?: boolean | undefined;
            disabled?: boolean | undefined;
            multiply?: boolean | undefined;
            tit?: string | undefined;
            field: string;
            itemIcon?: string | undefined;
            defaultVal?: string | undefined;
            defaultEditVal?: string | undefined;
            width?: number | undefined;
            maxHeight?: number | undefined;
            dropWidth?: number | undefined;
            directionUp?: boolean | undefined;
            noRequire?: boolean | undefined;
            renderCallback?: boolean | undefined;
            ableClear?: boolean | undefined;
            initComboVal?: {
                id: string;
            } | undefined;
            clickOrCheckForbid?: ((node: treeNode<T>, field: string, selectedArr: IImmutalbeList<ISelected>) => boolean) | undefined;
            editFn?: ((e: React.ChangeEvent<HTMLInputElement>) => void) | undefined;
            formatterVal?: ((selected: IImmutalbeList<ISelected>) => React.ReactChild) | undefined;
            formatterDropItem?: ((node: treeNode<T>, path: string) => React.ReactNode) | undefined;
            formatterComboInp?: ((object: {
                drop: boolean;
                selected: IImmutalbeList<ISelected>;
                slideFn(e: React.MouseEvent<Element, MouseEvent>): void;
                clearFn(): void;
            }) => React.ReactNode) | undefined;
            clickCallback(selected: ISelected[], field: string, node?: treeNode<T> | undefined): void;
            noautoFold?: boolean | undefined;
            children?: React.ReactNode;
        } & {
            childField?: string | undefined;
            noSearch?: boolean | undefined;
            parAbleClick?: boolean | undefined;
        }): void;
        dropToggle: () => void;
        initState(): {
            selected: IImmutalbeList<ISelected>;
            drop: boolean;
        };
        documentClickFn: () => void;
        componentDidMount(): void;
        componentWillUnmount(): void;
        initSelect: (selecteds: IImmutalbeList<ISelected>) => void;
        changeSelect: (selecteds: IImmutalbeList<ISelected>, node?: treeNode<T> | undefined) => void;
        renderComboInp(): string | number | boolean | React.ReactFragment | React.JSX.Element | null | undefined;
        renderCombox(): React.JSX.Element;
        render(): React.JSX.Element;
        context: unknown;
        setState<K extends keyof {
            selected: IImmutalbeList<ISelected>;
            drop: boolean;
        }>(state: {
            selected: IImmutalbeList<ISelected>;
            drop: boolean;
        } | ((prevState: Readonly<{
            selected: IImmutalbeList<ISelected>;
            drop: boolean;
        }>, props: Readonly<{
            data: T[];
            idField?: string | undefined;
            textField?: string | undefined;
            noIcon?: boolean | undefined;
            noSearch?: boolean | undefined;
            disabled?: boolean | undefined;
            multiply?: boolean | undefined;
            tit?: string | undefined;
            field: string;
            itemIcon?: string | undefined;
            defaultVal?: string | undefined;
            defaultEditVal?: string | undefined;
            width?: number | undefined;
            maxHeight?: number | undefined;
            dropWidth?: number | undefined;
            directionUp?: boolean | undefined;
            noRequire?: boolean | undefined;
            renderCallback?: boolean | undefined;
            ableClear?: boolean | undefined;
            initComboVal?: {
                id: string;
            } | undefined;
            clickOrCheckForbid?: ((node: treeNode<T>, field: string, selectedArr: IImmutalbeList<ISelected>) => boolean) | undefined;
            editFn?: ((e: React.ChangeEvent<HTMLInputElement>) => void) | undefined;
            formatterVal?: ((selected: IImmutalbeList<ISelected>) => React.ReactChild) | undefined;
            formatterDropItem?: ((node: treeNode<T>, path: string) => React.ReactNode) | undefined;
            formatterComboInp?: ((object: {
                drop: boolean;
                selected: IImmutalbeList<ISelected>;
                slideFn(e: React.MouseEvent<Element, MouseEvent>): void;
                clearFn(): void;
            }) => React.ReactNode) | undefined;
            clickCallback(selected: ISelected[], field: string, node?: treeNode<T> | undefined): void;
            noautoFold?: boolean | undefined;
            children?: React.ReactNode;
        } & {
            childField?: string | undefined;
            noSearch?: boolean | undefined;
            parAbleClick?: boolean | undefined;
        }>) => {
            selected: IImmutalbeList<ISelected>;
            drop: boolean;
        } | Pick<{
            selected: IImmutalbeList<ISelected>;
            drop: boolean;
        }, K> | null) | Pick<{
            selected: IImmutalbeList<ISelected>;
            drop: boolean;
        }, K> | null, callback?: (() => void) | undefined): void;
        forceUpdate(callback?: (() => void) | undefined): void;
        readonly props: Readonly<{
            data: T[];
            idField?: string | undefined;
            textField?: string | undefined;
            noIcon?: boolean | undefined;
            noSearch?: boolean | undefined;
            disabled?: boolean | undefined;
            multiply?: boolean | undefined;
            tit?: string | undefined;
            field: string;
            itemIcon?: string | undefined;
            defaultVal?: string | undefined;
            defaultEditVal?: string | undefined;
            width?: number | undefined;
            maxHeight?: number | undefined;
            dropWidth?: number | undefined;
            directionUp?: boolean | undefined;
            noRequire?: boolean | undefined;
            renderCallback?: boolean | undefined;
            ableClear?: boolean | undefined;
            initComboVal?: {
                id: string;
            } | undefined;
            clickOrCheckForbid?: ((node: treeNode<T>, field: string, selectedArr: IImmutalbeList<ISelected>) => boolean) | undefined;
            editFn?: ((e: React.ChangeEvent<HTMLInputElement>) => void) | undefined;
            formatterVal?: ((selected: IImmutalbeList<ISelected>) => React.ReactChild) | undefined;
            formatterDropItem?: ((node: treeNode<T>, path: string) => React.ReactNode) | undefined;
            formatterComboInp?: ((object: {
                drop: boolean;
                selected: IImmutalbeList<ISelected>;
                slideFn(e: React.MouseEvent<Element, MouseEvent>): void;
                clearFn(): void;
            }) => React.ReactNode) | undefined;
            clickCallback(selected: ISelected[], field: string, node?: treeNode<T> | undefined): void;
            noautoFold?: boolean | undefined;
            children?: React.ReactNode;
        } & {
            childField?: string | undefined;
            noSearch?: boolean | undefined;
            parAbleClick?: boolean | undefined;
        }>;
        state: Readonly<{
            selected: IImmutalbeList<ISelected>;
            drop: boolean;
        }>;
        refs: {
            [key: string]: React.ReactInstance;
        };
        shouldComponentUpdate?(nextProps: Readonly<{
            data: T[];
            idField?: string | undefined;
            textField?: string | undefined;
            noIcon?: boolean | undefined;
            noSearch?: boolean | undefined;
            disabled?: boolean | undefined;
            multiply?: boolean | undefined;
            tit?: string | undefined;
            field: string;
            itemIcon?: string | undefined;
            defaultVal?: string | undefined;
            defaultEditVal?: string | undefined;
            width?: number | undefined;
            maxHeight?: number | undefined;
            dropWidth?: number | undefined;
            directionUp?: boolean | undefined;
            noRequire?: boolean | undefined;
            renderCallback?: boolean | undefined;
            ableClear?: boolean | undefined;
            initComboVal?: {
                id: string;
            } | undefined;
            clickOrCheckForbid?: ((node: treeNode<T>, field: string, selectedArr: IImmutalbeList<ISelected>) => boolean) | undefined;
            editFn?: ((e: React.ChangeEvent<HTMLInputElement>) => void) | undefined;
            formatterVal?: ((selected: IImmutalbeList<ISelected>) => React.ReactChild) | undefined;
            formatterDropItem?: ((node: treeNode<T>, path: string) => React.ReactNode) | undefined;
            formatterComboInp?: ((object: {
                drop: boolean;
                selected: IImmutalbeList<ISelected>;
                slideFn(e: React.MouseEvent<Element, MouseEvent>): void;
                clearFn(): void;
            }) => React.ReactNode) | undefined;
            clickCallback(selected: ISelected[], field: string, node?: treeNode<T> | undefined): void;
            noautoFold?: boolean | undefined;
            children?: React.ReactNode;
        } & {
            childField?: string | undefined;
            noSearch?: boolean | undefined;
            parAbleClick?: boolean | undefined;
        }>, nextState: Readonly<{
            selected: IImmutalbeList<ISelected>;
            drop: boolean;
        }>, nextContext: any): boolean;
        componentDidCatch?(error: Error, errorInfo: React.ErrorInfo): void;
        getSnapshotBeforeUpdate?(prevProps: Readonly<{
            data: T[];
            idField?: string | undefined;
            textField?: string | undefined;
            noIcon?: boolean | undefined;
            noSearch?: boolean | undefined;
            disabled?: boolean | undefined;
            multiply?: boolean | undefined;
            tit?: string | undefined;
            field: string;
            itemIcon?: string | undefined;
            defaultVal?: string | undefined;
            defaultEditVal?: string | undefined;
            width?: number | undefined;
            maxHeight?: number | undefined;
            dropWidth?: number | undefined;
            directionUp?: boolean | undefined;
            noRequire?: boolean | undefined;
            renderCallback?: boolean | undefined;
            ableClear?: boolean | undefined;
            initComboVal?: {
                id: string;
            } | undefined;
            clickOrCheckForbid?: ((node: treeNode<T>, field: string, selectedArr: IImmutalbeList<ISelected>) => boolean) | undefined;
            editFn?: ((e: React.ChangeEvent<HTMLInputElement>) => void) | undefined;
            formatterVal?: ((selected: IImmutalbeList<ISelected>) => React.ReactChild) | undefined;
            formatterDropItem?: ((node: treeNode<T>, path: string) => React.ReactNode) | undefined;
            formatterComboInp?: ((object: {
                drop: boolean;
                selected: IImmutalbeList<ISelected>;
                slideFn(e: React.MouseEvent<Element, MouseEvent>): void;
                clearFn(): void;
            }) => React.ReactNode) | undefined;
            clickCallback(selected: ISelected[], field: string, node?: treeNode<T> | undefined): void;
            noautoFold?: boolean | undefined;
            children?: React.ReactNode;
        } & {
            childField?: string | undefined;
            noSearch?: boolean | undefined;
            parAbleClick?: boolean | undefined;
        }>, prevState: Readonly<{
            selected: IImmutalbeList<ISelected>;
            drop: boolean;
        }>): any;
        componentDidUpdate?(prevProps: Readonly<{
            data: T[];
            idField?: string | undefined;
            textField?: string | undefined;
            noIcon?: boolean | undefined;
            noSearch?: boolean | undefined;
            disabled?: boolean | undefined;
            multiply?: boolean | undefined;
            tit?: string | undefined;
            field: string;
            itemIcon?: string | undefined;
            defaultVal?: string | undefined;
            defaultEditVal?: string | undefined;
            width?: number | undefined;
            maxHeight?: number | undefined;
            dropWidth?: number | undefined;
            directionUp?: boolean | undefined;
            noRequire?: boolean | undefined;
            renderCallback?: boolean | undefined;
            ableClear?: boolean | undefined;
            initComboVal?: {
                id: string;
            } | undefined;
            clickOrCheckForbid?: ((node: treeNode<T>, field: string, selectedArr: IImmutalbeList<ISelected>) => boolean) | undefined;
            editFn?: ((e: React.ChangeEvent<HTMLInputElement>) => void) | undefined;
            formatterVal?: ((selected: IImmutalbeList<ISelected>) => React.ReactChild) | undefined;
            formatterDropItem?: ((node: treeNode<T>, path: string) => React.ReactNode) | undefined;
            formatterComboInp?: ((object: {
                drop: boolean;
                selected: IImmutalbeList<ISelected>;
                slideFn(e: React.MouseEvent<Element, MouseEvent>): void;
                clearFn(): void;
            }) => React.ReactNode) | undefined;
            clickCallback(selected: ISelected[], field: string, node?: treeNode<T> | undefined): void;
            noautoFold?: boolean | undefined;
            children?: React.ReactNode;
        } & {
            childField?: string | undefined;
            noSearch?: boolean | undefined;
            parAbleClick?: boolean | undefined;
        }>, prevState: Readonly<{
            selected: IImmutalbeList<ISelected>;
            drop: boolean;
        }>, snapshot?: any): void;
        componentWillMount?(): void;
        UNSAFE_componentWillMount?(): void;
        componentWillReceiveProps?(nextProps: Readonly<{
            data: T[];
            idField?: string | undefined;
            textField?: string | undefined;
            noIcon?: boolean | undefined;
            noSearch?: boolean | undefined;
            disabled?: boolean | undefined;
            multiply?: boolean | undefined;
            tit?: string | undefined;
            field: string;
            itemIcon?: string | undefined;
            defaultVal?: string | undefined;
            defaultEditVal?: string | undefined;
            width?: number | undefined;
            maxHeight?: number | undefined;
            dropWidth?: number | undefined;
            directionUp?: boolean | undefined;
            noRequire?: boolean | undefined;
            renderCallback?: boolean | undefined;
            ableClear?: boolean | undefined;
            initComboVal?: {
                id: string;
            } | undefined;
            clickOrCheckForbid?: ((node: treeNode<T>, field: string, selectedArr: IImmutalbeList<ISelected>) => boolean) | undefined;
            editFn?: ((e: React.ChangeEvent<HTMLInputElement>) => void) | undefined;
            formatterVal?: ((selected: IImmutalbeList<ISelected>) => React.ReactChild) | undefined;
            formatterDropItem?: ((node: treeNode<T>, path: string) => React.ReactNode) | undefined;
            formatterComboInp?: ((object: {
                drop: boolean;
                selected: IImmutalbeList<ISelected>;
                slideFn(e: React.MouseEvent<Element, MouseEvent>): void;
                clearFn(): void;
            }) => React.ReactNode) | undefined;
            clickCallback(selected: ISelected[], field: string, node?: treeNode<T> | undefined): void;
            noautoFold?: boolean | undefined;
            children?: React.ReactNode;
        } & {
            childField?: string | undefined;
            noSearch?: boolean | undefined;
            parAbleClick?: boolean | undefined;
        }>, nextContext: any): void;
        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<{
            data: T[];
            idField?: string | undefined;
            textField?: string | undefined;
            noIcon?: boolean | undefined;
            noSearch?: boolean | undefined;
            disabled?: boolean | undefined;
            multiply?: boolean | undefined;
            tit?: string | undefined;
            field: string;
            itemIcon?: string | undefined;
            defaultVal?: string | undefined;
            defaultEditVal?: string | undefined;
            width?: number | undefined;
            maxHeight?: number | undefined;
            dropWidth?: number | undefined;
            directionUp?: boolean | undefined;
            noRequire?: boolean | undefined;
            renderCallback?: boolean | undefined;
            ableClear?: boolean | undefined;
            initComboVal?: {
                id: string;
            } | undefined;
            clickOrCheckForbid?: ((node: treeNode<T>, field: string, selectedArr: IImmutalbeList<ISelected>) => boolean) | undefined;
            editFn?: ((e: React.ChangeEvent<HTMLInputElement>) => void) | undefined;
            formatterVal?: ((selected: IImmutalbeList<ISelected>) => React.ReactChild) | undefined;
            formatterDropItem?: ((node: treeNode<T>, path: string) => React.ReactNode) | undefined;
            formatterComboInp?: ((object: {
                drop: boolean;
                selected: IImmutalbeList<ISelected>;
                slideFn(e: React.MouseEvent<Element, MouseEvent>): void;
                clearFn(): void;
            }) => React.ReactNode) | undefined;
            clickCallback(selected: ISelected[], field: string, node?: treeNode<T> | undefined): void;
            noautoFold?: boolean | undefined;
            children?: React.ReactNode;
        } & {
            childField?: string | undefined;
            noSearch?: boolean | undefined;
            parAbleClick?: boolean | undefined;
        }>, nextContext: any): void;
        componentWillUpdate?(nextProps: Readonly<{
            data: T[];
            idField?: string | undefined;
            textField?: string | undefined;
            noIcon?: boolean | undefined;
            noSearch?: boolean | undefined;
            disabled?: boolean | undefined;
            multiply?: boolean | undefined;
            tit?: string | undefined;
            field: string;
            itemIcon?: string | undefined;
            defaultVal?: string | undefined;
            defaultEditVal?: string | undefined;
            width?: number | undefined;
            maxHeight?: number | undefined;
            dropWidth?: number | undefined;
            directionUp?: boolean | undefined;
            noRequire?: boolean | undefined;
            renderCallback?: boolean | undefined;
            ableClear?: boolean | undefined;
            initComboVal?: {
                id: string;
            } | undefined;
            clickOrCheckForbid?: ((node: treeNode<T>, field: string, selectedArr: IImmutalbeList<ISelected>) => boolean) | undefined;
            editFn?: ((e: React.ChangeEvent<HTMLInputElement>) => void) | undefined;
            formatterVal?: ((selected: IImmutalbeList<ISelected>) => React.ReactChild) | undefined;
            formatterDropItem?: ((node: treeNode<T>, path: string) => React.ReactNode) | undefined;
            formatterComboInp?: ((object: {
                drop: boolean;
                selected: IImmutalbeList<ISelected>;
                slideFn(e: React.MouseEvent<Element, MouseEvent>): void;
                clearFn(): void;
            }) => React.ReactNode) | undefined;
            clickCallback(selected: ISelected[], field: string, node?: treeNode<T> | undefined): void;
            noautoFold?: boolean | undefined;
            children?: React.ReactNode;
        } & {
            childField?: string | undefined;
            noSearch?: boolean | undefined;
            parAbleClick?: boolean | undefined;
        }>, nextState: Readonly<{
            selected: IImmutalbeList<ISelected>;
            drop: boolean;
        }>, nextContext: any): void;
        UNSAFE_componentWillUpdate?(nextProps: Readonly<{
            data: T[];
            idField?: string | undefined;
            textField?: string | undefined;
            noIcon?: boolean | undefined;
            noSearch?: boolean | undefined;
            disabled?: boolean | undefined;
            multiply?: boolean | undefined;
            tit?: string | undefined;
            field: string;
            itemIcon?: string | undefined;
            defaultVal?: string | undefined;
            defaultEditVal?: string | undefined;
            width?: number | undefined;
            maxHeight?: number | undefined;
            dropWidth?: number | undefined;
            directionUp?: boolean | undefined;
            noRequire?: boolean | undefined;
            renderCallback?: boolean | undefined;
            ableClear?: boolean | undefined;
            initComboVal?: {
                id: string;
            } | undefined;
            clickOrCheckForbid?: ((node: treeNode<T>, field: string, selectedArr: IImmutalbeList<ISelected>) => boolean) | undefined;
            editFn?: ((e: React.ChangeEvent<HTMLInputElement>) => void) | undefined;
            formatterVal?: ((selected: IImmutalbeList<ISelected>) => React.ReactChild) | undefined;
            formatterDropItem?: ((node: treeNode<T>, path: string) => React.ReactNode) | undefined;
            formatterComboInp?: ((object: {
                drop: boolean;
                selected: IImmutalbeList<ISelected>;
                slideFn(e: React.MouseEvent<Element, MouseEvent>): void;
                clearFn(): void;
            }) => React.ReactNode) | undefined;
            clickCallback(selected: ISelected[], field: string, node?: treeNode<T> | undefined): void;
            noautoFold?: boolean | undefined;
            children?: React.ReactNode;
        } & {
            childField?: string | undefined;
            noSearch?: boolean | undefined;
            parAbleClick?: boolean | undefined;
        }>, nextState: Readonly<{
            selected: IImmutalbeList<ISelected>;
            drop: boolean;
        }>, nextContext: any): void;
    };
    defaultProps: {
        idField: string;
        textField: string;
        childField: string;
        width: number;
        maxHeight: number;
        defaultVal: string;
        clickOrCheckForbid: () => boolean;
    };
    contextType?: React.Context<any> | undefined;
};
export default _default;
