import React from "react";
import { IImmutalbeMap, IImmutalbeList, ImmuTreeNode } from "../util/immutableUtil";
import { props } from "../input/Checkbox";
export interface Inode {
    active: string;
    expand: boolean;
    _path: string;
}
export interface ISelected {
    id: string;
    text: string;
    parIds: string;
}
export interface IDropObj {
    tree: {
        childField?: string;
        noSearch?: boolean;
        parAbleClick?: boolean;
    };
    list: {};
}
export type filedObj<P extends keyof IDropObj, T> = {
    idField: string;
    textField: string;
    multiply?: boolean;
    noSearch?: boolean;
    itemIcon?: string;
    defaultVal?: string;
    children?: React.ReactNode;
    parAbleClick?: boolean;
    field: string;
    clickOrCheckForbid: (node: P extends "list" ? listNode<T> : treeNode<T>, field: string, selectedArr?: IImmutalbeList<ISelected>) => boolean;
} & IDropObj[P];
export interface Idrop<P extends keyof IDropObj, K> {
    filedObj: IImmutalbeMap<filedObj<P, K>>;
    initComboVal?: {
        id: string;
    };
    disabled?: boolean;
    data: K[];
    selected: IImmutalbeList<ISelected>;
    dropStyle: {
        maxHeight: number;
    };
    formatterDropItem?: (node: getNodeType<P, K>, path: string) => React.ReactNode;
    clickMethod: (clickFn: (path?: string) => void) => void;
    changeSelect: (iselected: IImmutalbeList<ISelected>, node?: getNodeType<P, K>) => void;
    initSelect: (iselected: IImmutalbeList<ISelected>) => void;
    children?: React.ReactNode;
}
export type ICheckboxCom = props;
export type treeNode<T> = IImmutalbeMap<ImmuTreeNode<Inode & T>, Inode & T>;
export type listNode<T> = IImmutalbeMap<Inode & T, Inode & T>;
export type getNodeType<P extends keyof IDropObj, T> = P extends "tree" ? treeNode<T> : listNode<T>;
export type treeKey<T> = Exclude<keyof T, "children">;
