import * as React from "react";
import { GroupCols } from "./GroupCols";
import { activeStatus } from "./formatterTreeData";
import { ICommon, TreeTabNode } from "./mytreeTable";
import { IImmutalbeList } from "../../util/immutableUtil";
import { IScrollMethods } from "../../scroll/scroll";
type childType<T extends AnyObj> = React.ComponentElement<ICommon<T>["groupCol"], React.ComponentState>;
type Props<T extends AnyObj> = {
    data: T[];
    children: childType<T>[] | childType<T>;
    tabStyle?: "stripe";
    slectField?: string;
    noOrder?: boolean;
    fileOrder?: boolean;
    height?: number;
    multiply?: boolean;
    itemIcon?: ICommon<T>["fixObj"]["itemIcon"];
    childField?: string;
    noexpand?: boolean | string;
    originScroll?: boolean;
    bindChangeFn?: (fn: <k>(obj?: {
        val: k;
        path: string[];
        callback?: (d: States<T>["immutabData"]) => void;
    }) => (States<T>["immutabData"] | void), tabField?: string) => void;
    idField: string;
    defaultSel?: string;
    tabField?: string;
    emptyTxt?: string | ((field?: string) => React.ReactChild);
    initSelectVal?: {
        id: string;
    };
    clickOrCheckForbid?: (node: TreeTabNode<T>, field?: string) => boolean;
};
type States<T extends AnyObj> = {
    immutabData: IImmutalbeList<TreeTabNode<ICommon<T>["node"]>>;
    selectArr: IImmutalbeList<string>;
    preData: T[];
    preInitSelect?: {
        id: string;
    };
    isreLoad: AnyObj;
    oldSlect: string;
    noAnimate: {
        init: boolean;
    } | undefined;
};
type config<T extends AnyObj> = ICommon<T>["config"];
interface ITreeTable<T extends AnyObj> {
    fieldArr: config<T>[];
    fixObj: ICommon<T>["fixObj"];
}
declare class TreeTable<T extends AnyObj> extends React.PureComponent<Props<T>, States<T>> implements ITreeTable<T> {
    static defaultProps: {
        idField: string;
        childField: string;
        defaultSel: string;
    };
    static getDerivedStateFromProps(nextProps: Props<AnyObj>, preState: States<AnyObj>): Partial<States<AnyObj>> | null;
    fixObj: ITreeTable<T>["fixObj"];
    tabMainTabBodyDomArr: HTMLDivElement[];
    tabMainTabBodyScrollFnArr: (IScrollMethods | undefined)[];
    fieldArr: ITreeTable<T>["fieldArr"];
    preFieldArr: ITreeTable<T>["fieldArr"];
    constructor(props: Props<T>);
    shouldComponentUpdate(nextProps: Readonly<Props<T>>): boolean;
    getFieldArr(props: Props<T>): {
        child: (Omit<import("./mytreeTable").IColumnItem<T>, "children"> & {
            text: React.ReactNode;
        })[];
        width: number;
        forzen: boolean | undefined;
    }[];
    changeData: <k extends unknown>(obj?: {
        path: string[];
        val: k;
        callback?: ((d: States<T>["immutabData"]) => void) | undefined;
    } | undefined) => IImmutalbeList<TreeTabNode<import("./mytreeTable").Inode & T extends infer T_1 ? { [k_1 in keyof T_1]: k_1 extends keyof import("./mytreeTable").Inode ? import("./mytreeTable").Inode[k_1] : T[k_1]; } : never>> | undefined;
    expand(path: string): void;
    checkChild(path: string): void;
    mapFn(list: IImmutalbeList<TreeTabNode<T>>, active: activeStatus, select: IImmutalbeList<string>): {
        arr: import("immutable").List<TreeTabNode<T>>;
        selecte: IImmutalbeList<string>;
    };
    checkPar(path: string): void;
    changeState: ICommon<T>["changeState"];
    initFixObj(): {
        tabField: string | undefined;
        emptyTxt: string | ((field?: string | undefined) => React.ReactChild) | undefined;
        itemIcon: string | false | ((node: TreeTabNode<import("./mytreeTable").Inode & T extends infer T_1 ? { [k in keyof T_1]: k extends keyof import("./mytreeTable").Inode ? import("./mytreeTable").Inode[k] : T[k]; } : never>) => string) | undefined;
        noOrder: boolean | undefined;
        idField: string;
        multiply: boolean | undefined;
        defaultSel: string | undefined;
        childField: string;
        slectField: string | undefined;
        fileOrder: boolean | undefined;
    };
    changeScrollTop: (top: number, index: number) => void;
    viewMap(): React.JSX.Element[];
    setTabBodyDom: (dom: HTMLDivElement, index: number, scrollBoxFn?: IScrollMethods) => void;
    setTabViewBottomFixHeight(): void;
    componentDidMount(): void;
    setSameH(): void;
    setDom(): void;
    componentDidUpdate(preProps: Props<T>): void;
    mapDom(domArr: HTMLDivElement[]): void;
    whileDomH(): void;
    render(): React.JSX.Element;
}
export { TreeTable, GroupCols };
